<template>
 <v-page :header-text="headerText">
    <div class="reset-pass-page-container">
      <input
          v-model="email"
          type="email"
          placeholder="Email"
          ref="emailInput"
          @input="onInput"
          @keyup.enter="onResetPass"
      />
      <FormErrorMessage v-if="error">{{ error }}</FormErrorMessage>
      <br/>
      <v-button :in-progress="inProgress" @click="onResetPass">Reset password</v-button>
      <br/>
      <v-button-link to="/user-auth" @click="onBack">back</v-button-link>
    </div>
  </v-page>
</template>

<script>
  import { animateError, FormErrorMessage, VButton, VButtonLink, VPage } from 'zeus-common'

  import { createNamespacedHelpers } from 'vuex'
  import { ResetPassError } from './service'
  import { header as headerText } from '@/config'

  const { mapState } = createNamespacedHelpers('resetPass')

  export default {
    name: 'ResetPassPage',
    data: () => ({
      headerText: headerText,
      email: ''
    }),
    components: { FormErrorMessage, VButtonLink, VButton, VPage },
    computed: {
      ...mapState([ 'inProgress', 'error' ])
    },
    watch: {
      error(error) {
        if (error === ResetPassError.EMAIL_NOT_FOUND) {
          animateError(this.$refs.emailInput)
        }
      }
    },
    methods: {
      onResetPass() {
        this.onInput()
        if (!this.email) {
          animateError(this.$refs.emailInput)
          return
        }
        this.$store.dispatch('resetPass/resetPass', {
          email: this.email,
          onSuccess: (() => {
            this.$store.commit('passResetEmailSent/setEmail', this.email)
            this.$router.push('/pass-reset-email-sent')
          }).bind(this)
        })
      },
      onInput() {
        this.$store.commit('resetPass/resetError')
      },
      onBack() {
        this.$store.commit('resetPass/reset')
      }
    }
  }
</script>

<style scoped>
  .reset-pass-page-container {
    padding-top: 1.2em;
  }
</style>